'''
Created on Dec 17, 2015

@author: isvoboda
'''

# Process the results of OCR
# GT expected format: filename lp
# Eval expected format: filename x y width height lp
# Result: eval_filename x y width height lp GT:lp:n NMatch:n 

import sys
import difflib
import re
import argparse

re_key = re.compile(ur'PV-TP-I\d_\d{8}T\d{9}_\d')

def init_argparse():
  parser = argparse.ArgumentParser();
  parser.add_argument("-gt", "--ground-truth", help="Ground truth samples file.", required=True, type=str)
  parser.add_argument("-eval", "--evaluations", help="Results of OCR samples file.", required=True, type=str)
  return parser
  
  """Compute size of match of aligned strings
  Parameters
  ----------
  string_a : string
          first string
  string_b : string
          second string

  Returns
  -------
  int
          size of match of aligned strings
  """
def align_string(string_a, string_b):
  match = difflib.SequenceMatcher(None, string_a, string_b)
  n_sum = 0
  for (a_i, b_j, n) in match.get_matching_blocks():
    n_sum += n
    
  return n_sum

def main(argv):
  
  parser = init_argparse()
  args = parser.parse_args()
  
  with open(args.ground_truth, 'r') as gt_f:
    dict_lp = dict()
    for line in gt_f:
      line_sp = line.split()
      dict_lp[line_sp[0][0:-4]] = line_sp[1]
  
  with open(args.evaluations, 'r') as eval_f:
    for line in eval_f:
      match = re_key.search(line)
      if(match == None):
        print "Line: {} not in the ground truth dictionary, skipping.".format(line)
        continue
      line_sp = line.split()
      lp_ocr = line_sp[5] if len(line_sp) == 6 else ""
      key = match.group(0)
      n_match = align_string(dict_lp[key], lp_ocr)
      n_unknown = dict_lp[key].count("?")
      n_gt = len(dict_lp[key])
             
      print line.rstrip()+" GT:{}:{} NMatch:{}".format(dict_lp[key], n_gt-n_unknown, n_match)
  
  return 0

if __name__ == '__main__':
  main(sys.argv)